<template>
  <div class="home">
    <div class="page-part">
      <!-- <mt-header class="home-header">
        <router-link to="/" slot="left">
          <span class="title">{{$t('commonUser')}}</span>
        </router-link>
        <mt-button slot="right" >
          <img class="titleImg" src="../assets/images/create.png" @click="onMoreClick()"/>
        </mt-button>
     
      </mt-header> -->

      <mt-header fixed :title="appTitle" class="launch">  
        <mt-button icon="back" slot="left" @click="doBack"></mt-button>
       </mt-header>
      <div class="spaceHeader"></div>

      <div class="main-flex">
        <template v-for="(item, index) in commonMenu">
          <div v-if="index < 8" :key="item.id" class="main-flex-div" @click.stop="increaseNum(item.id)">
            <!-- <router-link :to="{name:'open', query:{linkType:'00',actionContent:item.formId}}" click.stop> -->
            <router-link to="/" @click.native="nav_click(item)" >
              <div v-if="item.ico != null && item.ico.icontype == 'img'" class="icon-comm">
                <span class="row-count" v-if="item.totalRow">{{item.totalRow}}</span>
                <img class="menu-img" :src="contextPath + item.ico.icon + aToken" />
              </div>
              <div v-if="item.ico != null && item.ico.icontype == 'font'" class="icon-comm">
                <span class="row-count" v-if="item.totalRow">{{item.totalRow}}</span>
                <i :class="'menu-font fa-2x '+ item.ico.icon" :style="{color: item.ico.iconFontColor}"></i>
              </div>
              <div v-if="item.ico == null" class="icon-comm">
                <span class="row-count" v-if="item.totalRow">{{item.totalRow}}</span>
                <img class="menu-img" src="../assets/images/defaultMenu.png"/>
              </div>
              <span class="favorites">{{item.description}}</span>
            </router-link>
          </div>
        </template>
        <template v-for="(item, index) in commonMenu" >
          <div :key="item.id" class="main-flex-div" v-if="index >= 8" v-show="showAllchang" @click.stop="increaseNum(item.id)">
            <!-- <router-link :to="{name:'open', query:{linkType:'00',actionContent:item.formId}}" click.stop> -->
            <router-link to="/" @click.native="nav_click(item)" >
              <div v-if="item.ico != null && item.ico.icontype == 'img'" class="icon-comm">
                <span class="row-count" v-if="item.totalRow">{{item.totalRow}}</span>
                <img class="menu-img" :src="contextPath + item.ico.icon + aToken" />
              </div>
              <div v-if="item.ico != null && item.ico.icontype == 'font'" class="icon-comm">
                 <span class="row-count" v-if="item.totalRow">{{item.totalRow}}</span>
                <i :class="'menu-font fa-2x '+ item.ico.icon" :style="{color: item.ico.iconFontColor}"></i>
              </div>
              <div v-if="item.ico == null">
                <img class="menu-img" src="../assets/images/defaultMenu.png"/>
              </div>
              <span class="favorites">{{item.description}}</span>
            </router-link>
          </div>
        </template>
        <div class="main-flex-div" v-show="showAllchang">
          <router-link to="/favoritesfunc">
            <img class="menu-img" src="../assets/images/addFavorites.png"/>
            <span class="favorites">{{$t('add')}}</span>
          </router-link>
        </div>
        <div class="main-flex-div" v-if="commonMenu == undefined || commonMenu.length < 8">
          <router-link to="/favoritesfunc">
            <img class="menu-img" src="../assets/images/addFavorites.png"/>
            <span class="favorites">{{$t('add')}}</span>
          </router-link>
        </div>
      </div>
      <div class="main-flex-more" @click="moreClick" v-if="commonMenu && commonMenu.length > 7">
        <img v-if="!showAllchang" src="../assets/images/show-menu.png"/>
        <div v-if="showAllchang" class="hide-common-menu"></div>
      </div>
    </div>
    <div class="page-part" style="margin-top:8px">
      <main_homepage />
    </div>
    <div class="v-modal popup-more" :style="{display:showMore?'block':'none'}" @click="onMaskClick"></div>
    <div class="mint-popup-more mint-popup-3 mint-popup-right-more"
      :style="{display:showMore?'block':'none'}">
      <div class="triangle"></div>
      <div class="popup-select" @click.stop="hideMoreDialog()">
        <router-link :to="{name:'launch'}" >
          <i class="fa fa-commenting fa-lg"></i>
          {{$t('initiateNew')}}
        </router-link>
      </div>
      <div class="popup-select" @click.stop="hideMoreDialog()">
        <router-link :to="{name:'menu'}">
          <i class="fa fa-th-large fa-lg"></i>
          {{$t('applicationMenu')}}
        </router-link>
      </div>
      <!-- <div class="popup-select">
        <router-link :to="{name:'flowcenter'}">
          <i class="fa fa-user-circle-o fa-lg"></i>
          我的代办
        </router-link>
      </div> -->
    </div>
  </div>
</template>

<script>
import main_homepage from "@/components/main_homepage.vue";
// import Constant from "@/Constant.js";
import API from "@/api.js";
import { Toast } from 'mint-ui';
export default {
  name: "Main",
  components: {
    main_homepage,
  },

  created(){
    this.aToken = "?accessToken=" + localStorage.getItem("accessToken")
    this.initChang()
  },
  mounted(){
    this.appTitle=document.title    
  },
  beforeRouteLeave(to, from, next) {
    let aa = 0//发起新建按钮/应用菜单点击，进入的页面初始滚动条位置为0
    this.$store.commit('saveScrollY', aa)
    next();
  },

  destroyed(){
    let b = document.getElementsByClassName('mint-popup'); //每次打开弹窗如果是挂载在body下，关闭弹窗，dom结构还在，所以页面关闭前，把挂载的弹窗都移除
    if(b && b.length > 0) {
      for (let i = 0; i < b.length; i++) {
        b[i].remove();
      }
    }
  },

  data:function(){
    return {
      commonMenu: {},
      showAllchang:false,
      contextPath: "",
      showMore: false,
      system_workflow:false,
      appTitle:'',
      aToken:'',
    }
  },

  methods:{
    doBack() {
      this.$router.go(-1)
    },
    hideMoreDialog() {
      this.showMore = false;
    },

    nav_click(item) {
      let initScrollTranslateY = 0;
      this.$store.commit('initScrollTranslateY', initScrollTranslateY) //点击进入视图时，视图滚动条初始0
      let id = item.formId?item.formId:item.viewId;
      if(item.formId) { //表单打开
        this.$api.hasPermissionToForm(this.$root.appid, id, {
          onSucess: res => {
            if(res.data.data) {
              this.$router.push({  
                name:'open',
                query:{linkType:'00',actionContent:item.formId}
              })
            }else {
              Toast(this.$t('notPermission'))
            }
          }
        });
      }else if (item.viewId) { //视图打开
        this.$api.hasPermissionToView(this.$root.appid, id, {
          onSucess: res => {
            if(res.data.data) {
              let params = {
                  linkType:'01',
                  actionContent:item.viewId, 
              };
              if(item.queryString) {
                params.queryString = item.queryString;
              }
              this.$router.push({  
                name:'open',
                query:params,
              })
            }else {
              Toast(this.$t('notPermission'))
            }
          }
        });
      }
    },

    onMaskClick() {
      this.showMore = false;
    },

    onMoreClick() {
      this.showMore = true;
    },

    //常用菜单增加点击次数
    increaseNum(id) {
      let appId = this.$root.appid;
      this.$api.updateUsedMenus(appId, id, {
        onSucess: () => {
          
        }
      });
    },

    initChang(){
      this.contextPath = obpmConfig.obpmFilePath;
      API.getCommonMenu(this.$root.appid, true, {
        onSucess: response => {
          this.commonMenu = response.data.data;
        }
      })
    },

    moreClick(){
      if(this.showAllchang == true){
        this.showAllchang=false;
      }else{
        this.showAllchang=true;
      }
    }
  }
};
</script>